import {Gamesystem} from "../../../project/game-model/gamesystems/Gamesystem";
import {SimpleGamesystem} from "../../../project/game-model/gamesystems/SimpleGamesystem";
import {ProductGamesystem} from "../../../project/game-model/gamesystems/ProductGamesystem";
import {State} from "../../../project/game-model/gamesystems/states/State";
import {SimpleState} from "../../../project/game-model/gamesystems/states/SimpleState";
import {ProductState} from "../../../project/game-model/gamesystems/states/ProductState";

export class LeafGamesystemCalculator {

  static calcLeafGeamesystems(gamesystem: Gamesystem<any, any>) {
    if(gamesystem instanceof SimpleGamesystem) {
      return [gamesystem];
    } else {
      const product_gamesystem = gamesystem as ProductGamesystem;
      const leaf_gamesystems: SimpleGamesystem[] = [];
      product_gamesystem.innerGamesystems.forEach(innerGamesystem => {
        LeafGamesystemCalculator.calcLeafGeamesystems(innerGamesystem).forEach(leafGamesystem => leaf_gamesystems.push(leafGamesystem))
      })
      return leaf_gamesystems;
    }
  }

  static calcLeafStates(state: State<any>) {
    if(state instanceof SimpleState) {
      return [state];
    } else {
      const productState = state as ProductState;
      const leafStates: SimpleState[] = [];
      productState.innerStates.forEach(innerState => {
        LeafGamesystemCalculator.calcLeafStates(innerState).forEach(leafState => leafStates.push(leafState));
      })
      return leafStates;
    }
  }
}
